import { Event } from "@codingame/monaco-vscode-api/vscode/vs/base/common/event";
import { Disposable } from "@codingame/monaco-vscode-api/vscode/vs/base/common/lifecycle";
import { KeymapInfo } from "../common/keymapInfo.js";
import { IKeyboardMapper } from "../../../../platform/keyboardLayout/common/keyboardMapper.js";
import { IKeyboardEvent } from "@codingame/monaco-vscode-api/vscode/vs/platform/keybinding/common/keybinding";
import { IFileService } from "@codingame/monaco-vscode-api/vscode/vs/platform/files/common/files.service";
import { IEnvironmentService } from "@codingame/monaco-vscode-api/vscode/vs/platform/environment/common/environment.service";
import { IConfigurationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/configuration/common/configuration.service";
import { INotificationService } from "@codingame/monaco-vscode-api/vscode/vs/platform/notification/common/notification.service";
import { ICommandService } from "@codingame/monaco-vscode-api/vscode/vs/platform/commands/common/commands.service";
import { IStorageService } from "@codingame/monaco-vscode-api/vscode/vs/platform/storage/common/storage.service";
import { IKeyboardLayoutInfo, IKeyboardMapping } from "@codingame/monaco-vscode-40cada32-7e9c-528a-81fc-766e4da54147-common/vscode/vs/platform/keyboardLayout/common/keyboardLayout";
import { IKeyboardLayoutService } from "@codingame/monaco-vscode-api/vscode/vs/platform/keyboardLayout/common/keyboardLayout.service";
export declare class BrowserKeyboardMapperFactoryBase extends Disposable {
    private readonly _configurationService;
    protected _initialized: boolean;
    protected _keyboardMapper: IKeyboardMapper | null;
    private readonly _onDidChangeKeyboardMapper;
    readonly onDidChangeKeyboardMapper: Event<void>;
    protected _keymapInfos: KeymapInfo[];
    protected _mru: KeymapInfo[];
    private _activeKeymapInfo;
    private keyboardLayoutMapAllowed;
    get activeKeymap(): KeymapInfo | null;
    get keymapInfos(): KeymapInfo[];
    get activeKeyboardLayout(): IKeyboardLayoutInfo | null;
    get activeKeyMapping(): IKeyboardMapping | null;
    get keyboardLayouts(): IKeyboardLayoutInfo[];
    protected constructor(_configurationService: IConfigurationService);
    registerKeyboardLayout(layout: KeymapInfo): void;
    removeKeyboardLayout(layout: KeymapInfo): void;
    getMatchedKeymapInfo(keyMapping: IKeyboardMapping | null): {
        result: KeymapInfo;
        score: number;
    } | null;
    getUSStandardLayout(): KeymapInfo | null;
    isKeyMappingActive(keymap: IKeyboardMapping | null): boolean | null;
    setUSKeyboardLayout(): void;
    setActiveKeyMapping(keymap: IKeyboardMapping | null): void;
    setActiveKeymapInfo(keymapInfo: KeymapInfo): void;
    setLayoutFromBrowserAPI(): void;
    private _updateKeyboardLayoutAsync;
    getKeyboardMapper(): IKeyboardMapper;
    validateCurrentKeyboardMapping(keyboardEvent: IKeyboardEvent): void;
    setKeyboardLayout(layoutName: string): void;
    private _setKeyboardData;
    private static _createKeyboardMapper;
    private _validateCurrentKeyboardMapping;
    private _getBrowserKeyMapping;
}
export declare class BrowserKeyboardMapperFactory extends BrowserKeyboardMapperFactoryBase {
    constructor(configurationService: IConfigurationService, notificationService: INotificationService, storageService: IStorageService, commandService: ICommandService);
}
export declare class BrowserKeyboardLayoutService extends Disposable implements IKeyboardLayoutService {
    private configurationService;
    _serviceBrand: undefined;
    private readonly _onDidChangeKeyboardLayout;
    readonly onDidChangeKeyboardLayout: Event<void>;
    private _userKeyboardLayout;
    private readonly _factory;
    private _keyboardLayoutMode;
    constructor(environmentService: IEnvironmentService, fileService: IFileService, notificationService: INotificationService, storageService: IStorageService, commandService: ICommandService, configurationService: IConfigurationService);
    setUserKeyboardLayoutIfMatched(): void;
    getKeyboardMapper(): IKeyboardMapper;
    getCurrentKeyboardLayout(): IKeyboardLayoutInfo | null;
    getAllKeyboardLayouts(): IKeyboardLayoutInfo[];
    getRawKeyboardMapping(): IKeyboardMapping | null;
    validateCurrentKeyboardMapping(keyboardEvent: IKeyboardEvent): void;
}
