import { IKeyboardLayoutInfo } from "@codingame/monaco-vscode-40cada32-7e9c-528a-81fc-766e4da54147-common/vscode/vs/platform/keyboardLayout/common/keyboardLayout";
export interface IRawMixedKeyboardMapping {
    [key: string]: {
        value: string;
        withShift: string;
        withAltGr: string;
        withShiftAltGr: string;
        valueIsDeadKey?: boolean;
        withShiftIsDeadKey?: boolean;
        withAltGrIsDeadKey?: boolean;
        withShiftAltGrIsDeadKey?: boolean;
    };
}
interface ISerializedMapping {
    [key: string]: (string | number)[];
}
export interface IKeymapInfo {
    layout: IKeyboardLayoutInfo;
    secondaryLayouts: IKeyboardLayoutInfo[];
    mapping: ISerializedMapping;
    isUserKeyboardLayout?: boolean;
}
export declare class KeymapInfo {
    layout: IKeyboardLayoutInfo;
    secondaryLayouts: IKeyboardLayoutInfo[];
    mapping: IRawMixedKeyboardMapping;
    isUserKeyboardLayout: boolean;
    constructor(layout: IKeyboardLayoutInfo, secondaryLayouts: IKeyboardLayoutInfo[], keyboardMapping: ISerializedMapping, isUserKeyboardLayout?: boolean);
    static createKeyboardLayoutFromDebugInfo(layout: IKeyboardLayoutInfo, value: IRawMixedKeyboardMapping, isUserKeyboardLayout?: boolean): KeymapInfo;
    update(other: KeymapInfo): void;
    getScore(other: IRawMixedKeyboardMapping): number;
    equal(other: KeymapInfo): boolean;
    fuzzyEqual(other: IRawMixedKeyboardMapping): boolean;
}
export {};
