import { KeyCode, ScanCode } from "@codingame/monaco-vscode-api/vscode/vs/base/common/keyCodes";
import { ResolvedKeybinding, KeyCodeChord, SingleModifierChord, ScanCodeChord, Keybinding } from "@codingame/monaco-vscode-api/vscode/vs/base/common/keybindings";
import { IKeyboardEvent } from "@codingame/monaco-vscode-api/vscode/vs/platform/keybinding/common/keybinding";
import { IKeyboardMapper } from "../../../../platform/keyboardLayout/common/keyboardMapper.js";
import { BaseResolvedKeybinding } from "@codingame/monaco-vscode-api/vscode/vs/platform/keybinding/common/baseResolvedKeybinding";
import { IWindowsKeyboardMapping } from "@codingame/monaco-vscode-40cada32-7e9c-528a-81fc-766e4da54147-common/vscode/vs/platform/keyboardLayout/common/keyboardLayout";
export interface IScanCodeMapping {
    scanCode: ScanCode;
    keyCode: KeyCode;
    value: string;
    withShift: string;
    withAltGr: string;
    withShiftAltGr: string;
}
export declare class WindowsNativeResolvedKeybinding extends BaseResolvedKeybinding<KeyCodeChord> {
    private readonly _mapper;
    constructor(mapper: WindowsKeyboardMapper, chords: KeyCodeChord[]);
    protected _getLabel(chord: KeyCodeChord): string | null;
    private _getUSLabelForKeybinding;
    getUSLabel(): string | null;
    protected _getAriaLabel(chord: KeyCodeChord): string | null;
    protected _getElectronAccelerator(chord: KeyCodeChord): string | null;
    protected _getUserSettingsLabel(chord: KeyCodeChord): string | null;
    protected _isWYSIWYG(chord: KeyCodeChord): boolean;
    private __isWYSIWYG;
    protected _getChordDispatch(chord: KeyCodeChord): string | null;
    protected _getSingleModifierChordDispatch(chord: KeyCodeChord): SingleModifierChord | null;
    private static getProducedCharCode;
    static getProducedChar(chord: ScanCodeChord, mapping: IScanCodeMapping): string;
}
export declare class WindowsKeyboardMapper implements IKeyboardMapper {
    private readonly _isUSStandard;
    private readonly _mapAltGrToCtrlAlt;
    private readonly _codeInfo;
    private readonly _scanCodeToKeyCode;
    private readonly _keyCodeToLabel;
    private readonly _keyCodeExists;
    constructor(_isUSStandard: boolean, rawMappings: IWindowsKeyboardMapping, _mapAltGrToCtrlAlt: boolean);
    dumpDebugInfo(): string;
    private _leftPad;
    getUILabelForKeyCode(keyCode: KeyCode): string;
    getAriaLabelForKeyCode(keyCode: KeyCode): string;
    getUserSettingsLabelForKeyCode(keyCode: KeyCode): string;
    getElectronAcceleratorForKeyBinding(chord: KeyCodeChord): string | null;
    private _getLabelForKeyCode;
    resolveKeyboardEvent(keyboardEvent: IKeyboardEvent): WindowsNativeResolvedKeybinding;
    private _resolveChord;
    resolveKeybinding(keybinding: Keybinding): ResolvedKeybinding[];
}
